// -*- mode:C++ -*-

// file    : Ac_kick.h
// includes: class declaration for the Kick arbiter and actuator
//

#ifndef _AC_KICK_H
#define _AC_KICK_H 1

struct Kick_actuator
{
    int time;
    int valid;
    Vector target_g_vel;
};

class Ac_kick;

#include "Module.h"
#include "Arbiter.h"

class Ac_kick: public Module {
public:
    Ac_kick();
    ~Ac_kick();
    virtual void reset () {;}
    // function to serve other modules
    // no_trigger means that module is not executed by calling this function
    void no_trigger_read(Kick_actuator &to);
    int catched();
    void Init(EmptySamba *sambapointer);
    void invalidate_all();
protected:
    int transform();
    float kick_impulse(float dist, float end_spd);
    Arbiter *arbiter;
    Kick_cmd kick;
    Hold_cmd hold_cmd;
    
    Kick_actuator prev_kicks, curr_kicks;
    int curr_hold, prev_hold;
};

#endif 

// end of file



