// File   : Ac_suply.cc
// Author : Jussi Pajala
// Created: 10.3.1998

#include "decls.h"
#include "Ac_supply.h"

#include "interface.h"
// Interface is declared to be a global variable!!!
extern Interface interface;

/* constructor function */
Ac_supply::Ac_supply ()
{
  my_id = AC_SUPPLY_ID;
  inhibited = NO;
  view_change_cmd.valid = 0;
  cmd.valid = 0;
  
  if(Cons2::debug_level_startup()) fprintf (stderr, "Ac_supply: CONSTRUCTOR executed\n");
}


Ac_supply::~Ac_supply ()
{
     if(Cons2::debug_level_exit()) fprintf (stderr, "Ac_supply: DESTRUCTOR executed\n");
}

void Ac_supply::Init(EmptySamba *sambapointer)
{
    samba = sambapointer;
    be_jumpto_defloc = 
        (Be_jumpto_defloc*)samba->get_pointer( BE_JUMPTO_DEFLOC_ID );
    be_shout = 
        (Be_shout*)samba->get_pointer( BE_SHOUT_ID );
    arbiter = 
        (Arbiter*)samba->get_pointer( ARBITER_ID );
    
}

void Ac_supply::invalidate_all()
{
    cmd.valid = 0;
    view_change_cmd.valid = 0;
}

void Ac_supply::arbitrate ()
{
    // simple priority ordering 
    
    arbiter->read(view_change_cmd);
    if(view_change_cmd.valid){
//        cerr <<"JEE VALID HERE!" << endl;
        return;
    }
    
    be_shout->read(cmd);
    if(cmd.valid) return;
    
    be_jumpto_defloc->read(cmd);
    if(cmd.valid) return;
}

int Ac_supply::transform ()
{
    // read and arbitrate commands
    arbitrate();
    
    
    if(cmd.valid && cmd.type == MOVE_CMD_ID)
        interface.command_move(cmd.var1, cmd.var2);
    else if( cmd.valid && cmd.type == SAY_CMD_ID){
        interface.command_say(cmd.text);
    }
    else if(view_change_cmd.valid){//type == CHANGE_VQ_CMD_ID){
        interface.command_change_view(view_change_cmd.va,
                                      view_change_cmd.vq);
    }/* else {
        cerr << "COMMAND TYPE IS " << cmd.type << endl;
        // tnne tulee viel  sensoreitten taajuuden muutos
        cerr << "TYPE NOT RECOGNIZED BY SUPPLEMENTARY ACTUATOR!"<<endl
             << __FILE__ << " " << __LINE__ << endl;
        exit(1);
        }*/
    return 0;
}
/* end of file */



