/* file    : Be_jumpto_defloc.cc
 */

#include "decls.h"
#include "Be_jumpto_defloc.h"


Be_jumpto_defloc::Be_jumpto_defloc ()
{
     my_id = BE_JUMPTO_DEFLOC_ID;
     
     if(Cons2::debug_level_startup()) 
         cerr << "Be_jumpto_defloc: CONSTRUCTOR executed" << endl;
     
}


Be_jumpto_defloc::~Be_jumpto_defloc ()
{
     if(Cons2::debug_level_exit()) 
         cerr << "Be_jumpto_defloc: DESTRUCTOR executed" << endl;
}


void Be_jumpto_defloc::Init(EmptySamba *sambapointer)
{
    samba = sambapointer;
    //   sensor = (Sensor*)samba->get_pointer( SENSOR_ID );
    ma_me = (Ma_me*)samba->get_pointer( MA_ME_ID );
    vs_referee = (Vs_referee*)samba->get_pointer( VS_REFEREE_ID );
    ma_defloc =    (Ma_defloc*)    samba->get_pointer( MA_DEFLOC_ID );
}




// valid conds are satisfied when game is halted for some reason
// and location of the player is far enough from the default location
FLAG Be_jumpto_defloc::valid_conds ()
{
    vs_referee->read(referee);
    ma_defloc->read(defloc);
    if( !referee.valid ){
        cerr << "REFEREE NOT VALID!" << endl;
        exit(1);
    }
    
    if(referee.time_running) return NO;
    
    ma_me->read_exec(me);
    Vector temp;//( Cons2::def_x(), Cons2::def_y() );
    temp = defloc.g_loc /*temp*/ - me.g_loc;
    if( temp.get_len() < 2.0 ) return NO;
    
    return YES;
}

void Be_jumpto_defloc::read(Supply_cmd &to)
{
    check_executed();
    to = cmd;
}

int Be_jumpto_defloc::transform ()
{
    if(Cons2::debug_level() > 4) cerr << " transforming... " << endl;

    cmd.type = MOVE_CMD_ID;
    cmd.var1 = defloc.g_loc.get_x();
    if(cmd.var1 > -1.5) cmd.var1 = -1.5;
    cmd.var2 = defloc.g_loc.get_y();
    cmd.valid = 1;
    return 0;
}


/* end of file */



