// -*- mode:C++ -*-                                     
// File:   Be_shout.h                             
// Author: Jussi Pajala 1.5.1997,  jussip@tks.oulu.fi   
//
// this file declares class of the shout marker

#ifndef BE_SHOUT_H
#define BE_SHOUT_H

class Be_shout;


#include "Module.h"
//#include "Ac_supply.h" // for Supply_cmd struct
#include "Be_jumpto_defloc.h"
#include <Vs/Vs_referee.h>
#include <Ma/Ma_ball.h>
#include <Ma/Ma_opponent.h>
class Be_shout:public Module
{
public:
    Be_shout();
    ~Be_shout();
    virtual void reset(){ ;};  // do nothing in reset!!
    void Init(EmptySamba *sambapointer);
    void read(Supply_cmd &to);
    void invalidate_all();
protected:

    FLAG      valid_conds();  // used in Module::execute()
    int       transform();      // called by Module::execute()
    void put_loc_and_vel(char *message, int &i, 
                         Vector &loc, Vector &vel );
    void put_int(char *message, int &i, int value);
    
    Vs_referee *vs_referee;
    Ma_ball    *ma_ball;
    Ma_opponent *ma_opponent;
    All_players opponents;
    
    Referee_vs referee;
    Ball_marker ball;
    
    Supply_cmd shout;
    char teamname[9];
    
};

#endif
