// -*- mode:C++ -*-                                     
// File     :  Ball_state.h
// Author   :  Jussi Pajala
// Date     :  30.7.1997   

// 30.7.1997  V.0.5     The first version
// 1.8.1997   V.0.6     One (big) bug fixed
// 20.2.1998  v.1.5     A big change
#ifndef BALL_STATE_H
#define BALL_STATE_H

#include "Vector.h"
#include <Ab_ball_filter.h>

struct BState
{
    int time;
    int vel_set;   // tells if velocity set by set_target_vel()
    Vector vel;
    float x, y;    // global location
    float rob_x,rob_y;
};

//#define BALL_FILTER

class Ball_state 
{
public:
    Ball_state(int system_delay, float vel_red);
    ~Ball_state();
    
    void reset();
    void set_curr_time(int time);
    void set_curr_g_pos(Vector g_pos);
    void set_curr_g_vel(Vector speed);

    void set_rob_pos(Vector rob_pos,int time);
        
    void set_target_vel(Vector vel);
    
    void get_exec_params(Vector &v, Vector &g_pos);
    void get_curr_params(Vector &v, Vector &g_pos);
    
    void print_all_states();
    
protected:
    void fill_array();
    
    int curr_time;
    int delay;
    float decay;
#ifdef BALL_FILTER
    Ab_ball_filter *xfilter, *yfilter;
    float filter_x, filter_y, filter_vx, filter_vy;
#endif
    int NSTATES;
    BState *state;
};

#endif
