// -*- mode:C++ -*-                                     
// File:   Ma_defloc.h                             
// Author: Jussi Pajala 1.2.1998,  jussip@tks.oulu.fi   
//
// this file declares class of the defloc marker

#ifndef MA_DEFLOC_H
#define MA_DEFLOC_H

#include "Vector.h"
struct Defloc_marker
{
    Vector g_loc;
    Vector loc;
    int valid;
    
};

class Ma_defloc;


#include "Module.h"
#include <Ma/Ma_me.h>
#include <Ma/Ma_goal.h>
#include <Vs/Vs_referee.h>
#include <Ma/Ma_ball.h>
//#include <Vs/Vs_defence_wgt.h>

class Ma_defloc:public Module
{
public:
    Ma_defloc();
    ~Ma_defloc();
    void Init(EmptySamba *sambapointer);
    
    virtual void reset(){ ;};  // do nothing in reset!!
    
    void read(Defloc_marker &to);
protected:
    int       transform();      // called by Module::execute()
    
    void calculate_goal_keeper_defloc();

    void invalidate_all(); // invalidates all data produced by this module
    
// pointers to incoming buffers, connected when initialized
    Ma_me          *ma_me;         // *me_msig_in; 
    Ma_ball        *ma_ball;       // *ball_msig_in;
    Ma_goal        *ma_goal;       // *own_goal_in;
    Vs_referee     *vs_referee;    // *referee_in;
    
    // me marker variables
    Me_marker me_exec;
    // ball marker variables
    Ball_marker ball;

    Goal_marker own_goal;
    // defence weight virtual sensor variables
    float defence_wgt;
    
    // referee virtual sensor variables
    Referee_vs referee;
    int first_time;
    
    Defloc_marker defloc;
    // vectors helping in calculations
    Vector defence_g_loc, attack_g_loc, defence_to_attack;
    Vector start_g_loc;
};
#endif
