// -*- mode:C++ -*-                                     
// File:   Ma_goal.h                             
// Author: Jussi Pajala 18.3.1998,  jussip@tks.oulu.fi   
//
// this file declares class of the goal marker, which marks both goals

#ifndef MA_GOAL_H
#define MA_GOAL_H
#include "Vector.h"
#include "icomm.h"
struct Goal_locs
{
     Vector left;
     Vector right;
     Vector center;
};

struct Goal_marker
{
    Goal_locs g_loc;
    Goal_locs loc;
    //float angle;  NOT IN USE, because we calculate 
    //left and right poles here
    CERTAINTY cer;
    int valid;
};

class Ma_goal;


#include "Module.h"
#include "Ab_filter.h"
#include "Sensor.h"
#include "Ma_me.h"
class Ma_goal:public Module
{
public:
    Ma_goal();
    ~Ma_goal();
    void Init(EmptySamba *sambapointer);  // goes through incoming bufferlist and connects 
    
    virtual void reset(){ ;};  // do nothing in reset!!
    
    // functions to serve other modules
    void read_opp_goal(Goal_marker &to);
    void read_own_goal(Goal_marker &to);
protected:
    int       transform();      // called by Module::execute()
    void invalidate_all(); // invalidates all data produced by this module
    void calc_goal_data(Goal_marker &exec, 
                        Goal_marker &sens, 
                        Goal_sensor goal_sensor, 
                        Goal_locs G_LOC);
    
// pointers to incoming buffers, connected when initialized
    Ma_me  *ma_me;       // *me_msig_in;
    Sensor *sensor;      // *opp_goal_ssig_in *sensor_ssig_in;
    
    Goal_sensor opp_goal_sensor, own_goal_sensor;
    Goal_marker exec_opp_goal, exec_own_goal;
    Goal_marker sens_opp_goal, sens_own_goal;
    
    Me_marker me_sens;
    Me_marker me_exec;
    Goal_locs OWN_GOAL_G_LOC;
    Goal_locs OPP_GOAL_G_LOC;
    
};

#endif
