// -*- mode:C++ -*-                                     
// File:   Ma_offside.h                             
// Author:Antti Tikanmki 9.6.1998,  sunday@tks.oulu.fi
// this file declares class of the offside marker
#ifndef MA_OFFSIDE_H
#define MA_OFFSIDE_H

struct Offside_marker {
    Vector g_loc;
    Vector loc;
    int valid;
};

class Ma_offside;
#include "Module.h"
#include <Ma/Ma_me.h>
#include <Ma/Ma_opponent.h>

class Ma_offside:public Module
{
public:
    Ma_offside();
    ~Ma_offside();
    void Init(EmptySamba *sambapointer);
    virtual void reset(){ ;};  // do nothing in reset!!
    void read(Offside_marker &to);
    
protected:
    int       transform();      // called by Module::execute()
    void invalidate_all(); // invalidates all data produced by this module
    
// pointers to incoming buffers, connected when initialized
    Ma_me          *ma_me;         // *me_msig_in;
    Ma_ball        *ma_ball;
    Ma_opponent    *ma_opponent;
    Vs_referee     *vs_referee;
    
    Me_marker me_exec;
    Ball_marker ball;
    All_players opponents;
    Referee_vs referee;
    
    Offside_marker offside;
};
#endif
