// -*- mode:C++ -*-                                     
// File:   Ma_teammate.h                             
// Author: Jussi Pajala 1.5.1997,  jussip@tks.oulu.fi   
//
// this file declares class of the teammate marker

#ifndef _MA_TEAMMATE_H
#define _MA_TEAMMATE_H

#include "Vector.h"
#include "icomm.h"

struct Player_data
{
    Vector g_loc;
    Vector g_vel;
        
    Vector loc;
    Vector vel;
    
    Vector mix_vel;
    
    CERTAINTY cer;
    
    float norm_dist; // normalized distance calculated by marker
    int unum;
};

struct All_players
{
    Player_data player[11]; // player[me_unum] has no meaning,it's left empty
    int order[11]; // order of importance player[order[0]] 
                    // is the most important
    int valid;
};

class Ma_opponent; // this will be defined in Ma_opponent.h
class Ma_teammate; // and this is to be declared soon...

#include "Module.h"
#include "Ab_filter.h"
#include <Ma/Ma_me.h>
#include <Vs/Vs_team_audio.h>
#include "Sensor.h"

class Ma_teammate:public Module
{
public:
    Ma_teammate(int DO_NOTHING = 0 );
    ~Ma_teammate();
    
    void reset(){ ;};  // do nothing in reset!!
    
     // functions to serve other modules
    void read_player(int unum, Player_data &to);
    void read(All_players &to);
    void Init(EmptySamba *sambapointer);
protected:
    virtual int       transform();      

    virtual void read_players_from_sensors();
    virtual void find_plrs_with_unum();
    virtual void predict_and_identify();
    virtual void quess_unidentified();
    virtual void filter_and_compute_positions();
    virtual void identify_players();
    virtual void approximate_position();
    virtual void sort_output_array();
    virtual void advance_positions();
    virtual void trace();
    void invalidate_all(); // invalidates all data produced by this module

// pointers to modules whose data this module reads
    Ma_me *ma_me;                //*me_msig_in;
    Sensor *sensor;              //*players_ssig_in *sensor_ssig_in;
    Vs_team_audio *vs_team_audio; // *audio_vssig_in;
    Ma_opponent *ma_opponent;   //*opp_msig_in;
    
    int plr_count;  // number of players read from ssignal
     
    Player_sensor player_sensor[MAX_SEEN_PLAYERS];
    int test;
    
    Player_data marker_team[11+1];// all the players that may belong to 
    // this markers team 
    Ab_filter filt_g_x[11+1];     // filters for all the players 
    Ab_filter filt_g_y[11+1];     //
    
    Side marker_side;   // tells which side marker is marking, Side_L or Side_R
    
    Side Sensor_side[MAX_SEEN_PLAYERS];
    Player_data plrs[MAX_SEEN_PLAYERS];
    
    int use_filter[11+1]; // flag that indicates should filters be
    // used when estimating position while sensor
    // information is not available
    int identified[12];   // in this array we put '1' if player is identified
    
    Me_marker me_exec, me_sense;
    Team_audio_vs audio;
    
    All_players all;
};

#endif
