// -*- mode:C++ -*-                                     
// File     :  Robot_state.h
// Author   :  Jussi Pajala
// Date     :  30.7.1997   

// 30.7.1997  V.0.5     The first version
// 1.8.1997   V.0.6     One (big) bug fixed
// 20.2.1998  v.1.5     A big change
#ifndef ROBOT_STATE_H
#define ROBOT_STATE_H

#include "Vector.h"

struct State
{
    int time;
    float speed;
    float speed_dir;
    int speed_set;   // tells if speed set by set_target_speed()
    float heading;
    float heading_set; // tells if heading set by set_target_heading()
    float x, y;
};

class Robot_state 
{
public:
     Robot_state(int system_delay, float vel_red);
     ~Robot_state();
     
     void set_curr_time(int time, int time_running = 1);
     void set_curr_g_pos(Vector g_pos);
     void set_curr_speed(float speed);
     void set_curr_heading(float dir);
     
     void set_target_d_head(float dir);
     void set_target_speed(float speed);
     
     void get_exec_params(Vector &v, Vector &g_pos, float &heading);
     void get_curr_params(Vector &v, Vector &g_pos, float &heading);

    void print_all_states();
    void rfout_all_states();
    
protected:
     void fill_array(int);
          
     int curr_time;
     int delay;
     float decay;
     
     int NSTATES;
     State *state;
};

#endif
