// -*- c++ -*-
#include "State_machine.h"

class Goal_keeper:public State_machine
{
public:
    Goal_keeper(Arbiter *arbiterpointer);
// maybe this is not needed anyway...
//    virtual void print_state_name() { curr_state->print_state();}
};


class Gk_goto_defloc:public State_machine
{
public:
    Gk_goto_defloc(Arbiter *arbiterpointer);
    virtual int valid_conds();
protected:
    float g_angle_me_to_ball;
    float g_angle_looking_left;
    float g_angle_looking_right;
    float g_angle_defloc_to_me;

    friend class Gk_straight_forward;
    friend class Gk_straight_reverse;
    friend class Gk_left_forward;
    friend class Gk_right_forward;
    friend class Gk_left_reverse;
    friend class Gk_right_reverse;

    
};

class Gk_straight_forward:public Prim_state
{
public:
    Gk_straight_forward(Arbiter *arbiterpointer,Gk_goto_defloc *gk_gd);
    virtual int execute();// returns zero on success
    virtual int valid_conds();
protected:
    Gk_goto_defloc *defloc;
};

class Gk_straight_reverse:public Prim_state
{
public:    
    Gk_straight_reverse(Arbiter *arbiterpointer,Gk_goto_defloc *gk_g);
    virtual int execute();// returns zero on success
    virtual int valid_conds();
protected:
    Gk_goto_defloc *defloc;
};

class Gk_right_forward:public Prim_state
{
public:    
    Gk_right_forward(Arbiter *arbiterpointer,Gk_goto_defloc *gk_g);
    virtual int execute();// returns zero on success
    virtual int valid_conds();
protected:
    Gk_goto_defloc *defloc;
};

class Gk_left_forward:public Prim_state
{
public:    
    Gk_left_forward(Arbiter *arbiterpointer,Gk_goto_defloc *gk_g);
    virtual int execute();// returns zero on success
    virtual int valid_conds();
protected:
    Gk_goto_defloc *defloc;
};

class Gk_right_reverse:public Prim_state
{
public:    
    Gk_right_reverse(Arbiter *arbiterpointer,Gk_goto_defloc *gk_g);
    virtual int execute();// returns zero on success
    virtual int valid_conds();
protected:
    Gk_goto_defloc *defloc;
};

class Gk_left_reverse:public Prim_state
{
public:    
    Gk_left_reverse(Arbiter *arbiterpointer,Gk_goto_defloc *gk_g);
    virtual int execute();// returns zero on success
    virtual int valid_conds();
protected:
    Gk_goto_defloc *defloc;
};

class Gk_avoid_players:public Prim_state
{
public:    
    Gk_avoid_players(Arbiter *arbiterpointer,Gk_goto_defloc *gk_g);
    virtual int execute();// returns zero on success
    virtual int valid_conds();
protected:
    Gk_goto_defloc *defloc;
};

class Gk_hold_ball:public Prim_state
{
public:    
    Gk_hold_ball(Arbiter *arbiterpointer);
    virtual int execute();// returns zero on success
    virtual int valid_conds();
};


class Gk_catch_ball:public Catch_ball
{
public:
    Gk_catch_ball(Arbiter *arbiterpointer);
    virtual int valid_conds();
};

class Gk_special_situation: public State_machine
{
public:
    Gk_special_situation(Arbiter *arbiterpointer);
    virtual int valid_conds();
};
    
