// -*- mode:C++ -*-                                     
// File:   Ma_ball.h                             
// Author: Jussi Pajala 1.5.1997,  jussip@tks.oulu.fi   
//
// this file declares class of the ball marker

#ifndef VISUAL_H
#define VISUAL_H

class Visual;

#include "Module.h"
#include <Ma/Ma_me.h>
#include <Ma/Ma_ball.h>
#include <Ma/Ma_special_loc.h>
#include <v_producer.h>

class Visual:public Module
{
public:
    Visual();
    ~Visual();
    virtual void reset(){ ;};  // do nothing in reset!!
    void Init(EmptySamba *sambapointer);
    void invalidate_all(){;}
    
protected:
    int       transform();      // called by Module::execute()
    void      req_static_objects();
    FLAG      valid_conds();

    float min_x, max_x, min_y, max_y;
    float scaling;
    char name_str[20];
    char empty_str[1]; 
    
    v_producer *vis;
    
    Ma_me *ma_me;
    Ma_ball *ma_ball;
    Ma_teammate *ma_teammate;
    Ma_opponent *ma_opponent;
    Ma_special_loc *ma_specloc;
    
    All_players plrs;
    Ball_marker ball;
    Me_marker me_exec,me_sens;
};

#endif
