// -*- mode:C++ -*-                                     
// File:   Vs_team_audio.h                             
// Author: Jussi Pajala 30.6.1997,  jussip@tks.oulu.fi   
//


#ifndef VS_TEAM_AUDIO_H
#define VS_TEAM_AUDIO_H
#include "icomm.h"
#include "Vector.h"
struct Team_audio_vs
{
    Vector ball_g_loc;
    Vector ball_g_vel;
    int ball_valid;

    Vector opp_g_loc[11];
    Vector opp_g_vel[11];
    int opp_valid[11];
};

#include "Module.h"
#include "Ab_filter.h"
#include "fieldobject.h"
#include "Sensor.h"
#include <fstream.h>
     

class Vs_team_audio:public Module
{
public:
     Vs_team_audio();
     ~Vs_team_audio();

    void reset(){ ;};  // do nothing in reset!!
    void read(Team_audio_vs &to);
    void invalidate_all();
protected:

    int       transform();      // called by Module::execute()
    void      Init(EmptySamba *sambapointer);
    void      analyze_message(Audioinfo& message);
    void      get_loc_and_vel(char *message, int &p, 
                              Vector &loc, Vector &vel);
    void      get_int(char *message, int &p, int &value);
            
    Sensor *sensor;
    
    Audioinfo messages[MAX_HEARD_MSG];
    Team_audio_vs audio;
    
    int n_msg, msg_time;
    ID msg_id;
    
    char teamname[5];
    char side_char;
    
};

#endif

