// -*- mode:C++ -*-
/* file     : icomm.h
 * includes : declarations for data types and functions
 *            used in internal communication
 */

#ifndef _ICOMM_H
#define _ICOMM_H 1

#include <strings.h>
#include "trace.h"
#include "Vector.h"
// boolean values 
typedef enum {NOT_VALID = (-1), NO = 0, YES = 1} FLAG;

// certainty describes, how reliable data is. value 0
// describes totally unreliable data and 1.0 completely
// reliable
//
typedef float CERTAINTY;

// System states
//  
// After initialization the system goes automatically to SENSORS_ON
// state. After that, the state is changed according to user
// commands. Behaviors are inhibited based on the state information.
//

// System states
//  
// After initialization the system goes automatically to SENSORS_ON
// state. After that, the state is changed according to user
// commands. Behaviors are inhibited based on the state information.
//
typedef enum {
  INITIALIZING_SOCCER = 1,
  SENSORS_ON        = 2,
  LOOKAROUND_ON     = 3,
  BALL_BEHAVIORS_ON = 4,
  GOAL_BEHAVIORS_ON = 5,
  ALL_ON            = 6,
  QUIT_SOCCER       = 7,
  RESET_SOCCER      = 8,
  PAUSE_SOCCER      = 9
} SYSTEM_STATE;


// id numbers for modules and signals
typedef enum
{
     // HERE_THEY_ARE
     DEFAULT_ID = 0,
// actuators
     AC_BASE_ID, AC_KICK_ID, AC_SUPPLY_ID,
// arbiters
     ARBITER_ID,
// behaviors
// NISS ON TURHIA! POISTA
     BEHAVIOR_ID,         
     BE_KICKTOGOAL_ID, BE_LOOKAROUND_ID, BE_TURNTOBALL_ID,
     BE_MOVETOBALL_ID, BE_TURNTOGOAL_ID, BE_GOTO_BALL_ID,
     BE_MOVE_ID,
     BE_KICK_ID, 

// behaviors for special situations
     BE_GOTO_SPECIAL_LOC_ID,
     BE_JUMPTO_DEFLOC_ID, BE_SHOUT_ID, BE_KICK_SPECIAL_ID,
// sensor
     SENSOR_ID,
// virtual sensors
     VS_REFEREE_ID, VS_TEAM_AUDIO_ID, VS_DEFENCE_WGT_ID, VS_BALL_POSSD_ID,
     VS_RISK_LVL_ID,
// markers
     MA_ME_ID, MA_BALL_ID, MA_GOAL_ID, MA_BORDER_ID, MA_TEAMMATE_ID, MA_OPPONENT_ID,
     MA_FLAGS_ID, MA_DEFLOC_ID, MA_SPECIAL_LOC_ID, MA_OFFSIDE_ID,
// miscellanous
     USER_ID, VISUAL_ID,
     IDLE_ID, INHIBITED_ID, ACTIVE_ID, LAST_ID
} ID;




#endif 

/* end of file */
