// file : main.cc
// includes : the main function of a  program creating
//            a visualizer and sending drawing requests
//            to it through a pipe

#include <unistd.h>
#include <v_producer.h>

  
void set_dir (float dir_step, float &dir)
{
     dir += dir_step;
     if (dir > M_PI) dir -= 2*M_PI;
}


void set_coord_step (float value, float min_value, float max_value, float& step)
{
     if (step > 0 && value >= max_value) step = -1;
     if (step < 0 && value <= min_value) step = 1;
}

void increment (float min_value, float max_value, float& value, float& step)
{
     set_coord_step (value, min_value, max_value, step);
     value += step;
}


main (int argc, char *argv[])
{
     float x0=-30, y0=30, x0_step=1, y0_step=1;
     float dir1=0, dir1_step=0.01;
     float x2=30, y2=30, x2_step=0.5, y2_step=0.5;
     float dir3=0, dir3_step=0.001;
     float x4=15, y4=-20, x4_step=0.1, y4_step=0.1;
     float min_x = -52.5, max_x = 52.5, min_y = -34.0, max_y = 34.0;
     float scaling = 10.0;
     char name_str[20];
     char empty_str[1]; 
     empty_str[0] = '\0';
     char *title = "Environment state by player X";
     int max_dyn_obj_id=0, stat_obj_id=0;

     v_producer my_producer ("|/home/jpr/robocup98/bin/visualizer",
                             min_x, max_x, min_y, max_y, scaling, title);
     max_dyn_obj_id = my_producer.max_dyn_obj_id();
     stat_obj_id = my_producer.stat_obj_id ();
     cout << "VISUALIZER initialized, max_dyn_obj_id=" << max_dyn_obj_id 
          << " stat_obj_id=" << stat_obj_id << endl;
     sleep (1);

     // static objects

     sprintf (name_str,"STAT0");
     if (my_producer.send_req (stat_obj_id, V_OBJ_CIRC, -20, -20, 0, 2, name_str, V_RED) == -1)
          cerr << "Visualizing error detected!" << endl;

     sprintf (name_str,"STAT1");
     if (my_producer.send_req (stat_obj_id, V_OBJ_LSEG, 25, 0, dir1, 10, name_str, V_BLUE) == -1)
          cerr << "Visualizing error detected!" << endl;

     if (my_producer.send_req (stat_obj_id, V_OBJ_DISC, 30, 30, 0, 1, empty_str, V_GREEN) == -1)
          cerr << "Visualizing error detected!" << endl;

     sprintf (name_str,"STAT3");
     if (my_producer.send_req (stat_obj_id, V_OBJ_LSEG, 15,-15, dir3, 5, name_str, V_PINK) == -1)
          cerr << "Visualizing error detected!" << endl;

     sprintf (name_str,"STAT4");
     if (my_producer.send_req (stat_obj_id, V_OBJ_DISC, -15, 15, 0, 1.2, name_str, V_VIOLET) == -1)
          cerr << "Visualizing error detected!" << endl;

     if (my_producer.send_req (stat_obj_id, V_OBJ_LINE, -50, -30, 0, 100, empty_str, V_BLUE) == -1)
          cerr << "Visualizing error detected!" << endl;
     if (my_producer.send_req (stat_obj_id, V_OBJ_LINE,  50, -30, M_PI/2.0, 60, empty_str, V_BLUE) == -1)
          cerr << "Visualizing error detected!" << endl;
     if (my_producer.send_req (stat_obj_id, V_OBJ_LINE, -50,  30, 0, 100, empty_str, V_BLUE) == -1)
          cerr << "Visualizing error detected!" << endl;
     if (my_producer.send_req (stat_obj_id, V_OBJ_LINE, -50, -30, M_PI/2.0, 60, empty_str, V_BLUE) == -1)
          cerr << "Visualizing error detected!" << endl;

     // dynamic objects

     for (int cnt = 0; cnt < 2000; cnt++) 
          {
               sprintf (name_str,"DYN0");
               if (my_producer.send_req (0, V_OBJ_CIRC, x0, y0, 0, 2, name_str, V_RED) == -1)
                    cerr << "Visualizing error detected!" << endl;
               increment (min_x, max_x, x0, x0_step);
               increment (min_y, max_y, y0, y0_step);

               sprintf (name_str,"DYN1");
               my_producer.send_req (1, V_OBJ_LSEG, 0, 0, dir1, 10, name_str, V_BLUE);
               set_dir (dir1_step, dir1);

               my_producer.send_req (2, V_OBJ_DISC, x2, y2, 0, 1, empty_str, V_GREEN);
               increment (min_x, max_x, x2, x2_step);
               increment (min_y, max_y, y2, y2_step);

               sprintf (name_str,"DYN3");
               my_producer.send_req (3, V_OBJ_LSEG, 20,-10, dir3, 5, name_str, V_PINK);
               set_dir (dir3_step, dir3);

               sprintf (name_str,"DYN4");
               my_producer.send_req (4, V_OBJ_DISC, x4, y4, 0, 1.2, name_str, V_VIOLET);
               increment (min_x, max_x, x4, x4_step);
               increment (min_y, max_y, y4, y4_step);
          }
     my_producer.quit ();
}

/* end of file */
